#-
* This file is part of aITALC
* Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
*------------------------------------------------------------- 
** <joinkinematics.frm> tries to compose some kinematical variables
*-------------------------------------------------------------------------------
#include model.inc
#include Kit.inc
#include aITALC.inc
#include `processname'.in #exts1
#include `processname'.in #topologies0

#if `LEGS' == 4

CF BETA;
auto S m,u;

*-------------------------------------------------------------------------------
* Definition of the local variables Betas and Mandelstam t,u

L Betae=BETA(sman,m1^2,m2^2);
L Betaf=BETA(sman,m3^2,m4^2);
L Tman=-1/2*(sman - (m1^2+m2^2+m3^2+m4^2) + (m1^2-m2^2)*(m3^2-m4^2)/sman) 
       +1/2*sman*BETA(sman,m1^2,m2^2)*BETA(sman,m3^2,m4^2)*cost;

L Uman=-1/2*(sman - (m1^2+m2^2+m3^2+m4^2) - (m1^2-m2^2)*(m3^2-m4^2)/sman ) 
       -1/2*sman*BETA(sman,m1^2,m2^2)*BETA(sman,m3^2,m4^2)*cost;
*-------------------------------------------------------------------------------
* Identification with diana output.in

#do ipart=1,`LEGS'
  id m`ipart'=`em{`ipart'}';
  id u`ipart'=`u{`ipart'}';
  argument;
   id m`ipart'=`em{`ipart'}';
  endargument;
#enddo

** Possibility to neglect some masses defined in Neglectedmasses.inc
#call neglectmass(0)
argument;
** The zero is a double precision 0 for fortran arguments...
 #call neglectmass(zero)
endargument;
*-------------------------------------------------------------------------------

format doublefortran nospaces;
.sort
*-------------------------------------------------------------------------------
* Writing out the fortrans

#write <fluxfactor.F> "      double precision function FLUXFACTOR()"
#write <fluxfactor.F> ""
#write <fluxfactor.F> "      implicit none"
#write <fluxfactor.F> "      double precision bf,bi"
#write <fluxfactor.F> "#include <variablelist.hf>"
#write <fluxfactor.F> "C ----------------------------------------------------------------------"
#write <fluxfactor.F> "C In order to get the result in (pb) instead of (GeV^-2) use conversion"
#write <fluxfactor.F> ""
#write <fluxfactor.F> "      bf=%e",Betaf
#write <fluxfactor.F> "      bi=%e",Betae
#write <fluxfactor.F> "      if (bi.LE.0d0) then"
#write <fluxfactor.F> "        fluxfactor=0d0"
#write <fluxfactor.F> "      else"
#write <fluxfactor.F> "        fluxfactor= conversion*(bf/bi)/(32*Pi*sman)"
#write <fluxfactor.F> "      endif"
#write <fluxfactor.F> ""
#write <fluxfactor.F> "      return"
#write <fluxfactor.F> "      end"
*-------------------------------------------------------------------------------

#write <mandelstam.F> "      subroutine MANDELSTAM(vart,varu)"
#write <mandelstam.F> ""
#write <mandelstam.F> "      implicit none"
#write <mandelstam.F> "      double precision vart,varu"
#write <mandelstam.F> "#include <variablelist.hf>"
#write <mandelstam.F> "C ----------------------------------------------------------------------"
#write <mandelstam.F> ""
#write <mandelstam.F> "      vart=%e",Tman,vart
#write <mandelstam.F> "      varu=%e",Uman,varu
#write <mandelstam.F> ""
#write <mandelstam.F> "      return"
#write <mandelstam.F> "      end"
*-------------------------------------------------------------------------------

#write <momentum.F> "      SUBROUTINE MOMENTUM(K,PK0,MODPK,PLUSPK,MINUSPK,PK2)"
#write <momentum.F> ""
#write <momentum.F> "      IMPLICIT NONE"
#write <momentum.F> "      DOUBLE PRECISION PK0,MODPK,PLUSPK,MINUSPK,PK2"
#write <momentum.F> "      DOUBLE PRECISION OMSQRTOM"
#write <momentum.F> "      INTEGER K"
#write <momentum.F> "#include <variablelist.hf>"
#write <momentum.F> "C ----------------------------------------------------------------------"
#write <momentum.F> ""
#write <momentum.F> "C This is a solution only for 4 legs; 1,2 ingoing, 3,4 outgoing"
#write <momentum.F> ""
#write <momentum.F> "      IF ((K.LE.0).OR.(K.GE.5)) THEN"
#write <momentum.F> "        PRINT *,\"MOMENTUM: EXTERNAL LINE INDEX\",K,\"OUT OF RANGE\""
#write <momentum.F> "      ELSEIF (K.EQ.1) THEN"
#write <momentum.F> "        PK2=`em1'**2"
#write <momentum.F> "        PK0= (sman+PK2-`em2'**2)/(2*DSQRT(sman))"
#write <momentum.F> "      ELSEIF (K.EQ.2) THEN"
#write <momentum.F> "        PK2=`em2'**2"
#write <momentum.F> "        PK0= (sman+PK2-`em1'**2)/(2*DSQRT(sman))"
#write <momentum.F> "      ELSEIF (K.EQ.3) THEN"
#write <momentum.F> "        PK2=`em3'**2"
#write <momentum.F> "        PK0=-(sman+PK2-`em4'**2)/(2*DSQRT(sman))"
#write <momentum.F> "      ELSEIF (K.EQ.4) THEN"
#write <momentum.F> "        PK2=`em4'**2"
#write <momentum.F> "        PK0=-(sman+PK2-`em3'**2)/(2*DSQRT(sman))"
#write <momentum.F> "      ENDIF"
#write <momentum.F> "      MODPK= DSQRT(PK0**2-PK2)"
#write <momentum.F> "C Case of different signs for the PK0"
#write <momentum.F> "      IF (PK0.LT.0D0) THEN"
#write <momentum.F> "        MINUSPK=PK0-MODPK"
#write <momentum.F> "        PLUSPK= PK0*(OMSQRTOM(PK2/PK0**2))"
#write <momentum.F> "      ELSE"
#write <momentum.F> "        PLUSPK= PK0+MODPK"
#write <momentum.F> "        MINUSPK=PK0*(OMSQRTOM(PK2/PK0**2))"
#write <momentum.F> "      ENDIF"
#write <momentum.F> "C ----------------------------------------------------------------------"
#write <momentum.F> "      RETURN"
#write <momentum.F> "      END"
*-------------------------------------------------------------------------------

#write <softphoton.F> "      double precision function SOFTPHOTON(fraction)"
#write <softphoton.F> "      implicit none"
#write <softphoton.F> "      double precision fraction"
#write <softphoton.F> "      integer i1,i2"
#write <softphoton.F> "      double precision INTEGRATEDPHOTON"
#write <softphoton.F> "#include <variablelist.hf>"
#write <softphoton.F> "C ----------------------------------------------------------------------"
#write <softphoton.F> ""
#if     `LEVEL' == tree
* We do not show any soft-photon results
 #write <softphoton.F> "      SOFTPHOTON=0d0"
#elseif `LEVEL' == loop
#write <softphoton.F> "      SOFTPHOTON="
 #do ipart1=1,4
  #do ipart2=1,4
** Relative definition of ingoing-outgoing sign between legs!
   #if ((`ipart1' == 1) || (`ipart1' == 2)) && ((`ipart2' == 3) || (`ipart2' == 4))
    #define relativesign "-"
   #elseif ((`ipart1' == 3) || (`ipart1' == 4)) && ((`ipart2' == 1) || (`ipart2' == 2))
    #define relativesign "-"
   #else
    #define relativesign "+"
   #endif
#write <softphoton.F> "     &`relativesign'INTEGRATEDPHOTON(`ipart1',`ipart2',FRACTION,MMAsoft)*(`eq`ipart1'')*(`eq`ipart2'')"
  #enddo
 #enddo
#write <softphoton.F> ""
#write <softphoton.F> "      SOFTPHOTON=-e**2/(2*(2*pi)**3)*SOFTPHOTON"
#endif
#write <softphoton.F> ""
#write <softphoton.F> "      RETURN"
#write <softphoton.F> "      END"
*-------------------------------------------------------------------------------

** Also writing how to compose the differential cross section
** this is a bit more elaborated script-like...
.sort
#if     `LEVEL' == tree
 #include fermioncurrentsnames.in
 #define method "pure"
* try to compose only treetree stuff
#elseif `LEVEL' == loop
 #include fermioncurrentsnames.in
 #include ../tree/fermioncurrentsnames.in
 #message [joinkinematics: debug: at level `LEVEL', treefcn=`treefcn', loopfcn=`loopfcn']
* check if tree existed, then perform a treetree, treeloop and looploop
 #if "`treefcn'" == EMPTY
* only looploop
  #define method "pure"
 #else
  #define method "mixing"
* standard building
 #endif

#else
*What the hell!!!
#endif

#write <dcs.f> "      subroutine DCS(treetree,treeloop,looploop)"
#write <dcs.f> "C ----------------------------------------------------------------------"
#write <dcs.f> "      implicit none"
#write <dcs.f> "      double precision treetree,treeloop,looploop"
#write <dcs.f> "      double complex ctreetree,ctreeloop,clooploop"
#write <dcs.f> "      double precision dcsfactor"
#write <dcs.f> "      double precision FLUXFACTOR"
#write <dcs.f> "      integer i1,i2,j1,j2"
#write <dcs.f> "      "
#if `method' == pure
 #define thelevels "`LEVEL'"
#elseif `method' == mixing
 #define thelevels "tree,loop"
#else
 #message [joinkinematics: method not matching "pure" or "mixing" = `method']
#endif

#message [joinkinematics: debug: method=`method', thelevels=`thelevels']
#do mylevel ={`thelevels'}
#message [joinkinematics: debug: ch1= ``mylevel'fcn' ]
#do ch1={``mylevel'fcn'} 
#write <dcs.f> "      double complex ff_`ch1'_`mylevel'(9,4)"
#enddo
#enddo

#do ch1={``LEVEL'fcn'}
 #do ch2={``LEVEL'fcn'}
#write <dcs.f> "      double precision mm_`ch1'`ch2'(9,4,9,4)"
 #enddo
#enddo
#write <dcs.f> "C ----------------------------------------------------------------------"
#write <dcs.f> "C Call of the form factors for tree and loop amplitudes"


#do mylevel ={`thelevels'}
#do ch1={``mylevel'fcn'}
#write <dcs.f> "      CALL F_`ch1'_`mylevel'(ff_`ch1'_`mylevel')"
#enddo
#enddo

#write <dcs.f> ""
#write <dcs.f> "C And call of the matrix elements for required fermion currents"
#do ch1={``LEVEL'fcn'}
 #do ch2={``LEVEL'fcn'}
#write <dcs.f> "      CALL M_`ch1'`ch2'(mm_`ch1'`ch2')"
 #enddo
#enddo
#write <dcs.f> "C ----------------------------------------------------------------------"
#write <dcs.f> "      ctreetree= DCMPLX(0)"
#write <dcs.f> "      ctreeloop= DCMPLX(0)"
#write <dcs.f> "      clooploop= DCMPLX(0)"
#write <dcs.f> "C ----------------------------------------------------------------------"
#write <dcs.f> "C Building the amplitude square for the different contributions"
#write <dcs.f> ""
#write <dcs.f> "      DO j2=1,4"
#write <dcs.f> "        DO j1=1,9"
#write <dcs.f> "          DO i2=1,4"
#write <dcs.f> "            DO i1=1,9"
#write <dcs.f> "C"

** Writing now the sums
#if `method' == pure
** Only one of the levels
#write <dcs.f> "              c`LEVEL'`LEVEL'= c`LEVEL'`LEVEL'"
#do ch1={``LEVEL'fcn'}
#write <dcs.f> "     & + DCONJG(ff_`ch1'_`LEVEL'(i1,i2))*("
 #do ch2={``LEVEL'fcn'}
#write <dcs.f> "     & + mm_`ch1'`ch2'(i1,i2,j1,j2)*ff_`ch2'_`LEVEL'(j1,j2) !mixing `ch1'`ch2'"
 #enddo
#write <dcs.f> "     & )"
#enddo

#else
** For the mixing
#write <dcs.f> "              ctreetree= ctreetree"
#do ch1={`treefcn'}
#write <dcs.f> "     & + DCONJG(ff_`ch1'_tree(i1,i2))*("
 #do ch2={`treefcn'}
#write <dcs.f> "     & + mm_`ch1'`ch2'(i1,i2,j1,j2)*ff_`ch2'_tree(j1,j2) !mixing `ch1'`ch2'"
 #enddo
#write <dcs.f> "     & )"
#enddo
#write <dcs.f> "C"
#write <dcs.f> "              ctreeloop= ctreeloop"
#do ch1={`treefcn'}
#write <dcs.f> "     & + DCONJG(ff_`ch1'_tree(i1,i2))*("
 #do ch2={`loopfcn'}
#write <dcs.f> "     & + mm_`ch1'`ch2'(i1,i2,j1,j2)*ff_`ch2'_loop(j1,j2) !mixing `ch1'`ch2'"
 #enddo
#write <dcs.f> "     & )"
#enddo
#write <dcs.f> "C"
#write <dcs.f> "              clooploop= clooploop"
#do ch1={`loopfcn'}
#write <dcs.f> "     & + DCONJG(ff_`ch1'_loop(i1,i2))*("
 #do ch2={`loopfcn'}
#write <dcs.f> "     & + mm_`ch1'`ch2'(i1,i2,j1,j2)*ff_`ch2'_loop(j1,j2) !mixing `ch1'`ch2'"
 #enddo
#write <dcs.f> "     & )"
#enddo

#endif

#write <dcs.f> "            ENDDO"
#write <dcs.f> "          ENDDO"
#write <dcs.f> "        ENDDO"
#write <dcs.f> "      ENDDO"
#write <dcs.f> "C ----------------------------------------------------------------------"
#if `LEGS' == 4
 #if ((`emm3' == `emm4') && (`u3' == `u4'))
  #write <dcs.f> "CC Factor 1/2 is typical for identical particles in final state."
  #define IDENTICAL "/2"
 #else
  #define IDENTICAL ""
 #endif
#endif
#write <dcs.f> "      dcsfactor= FLUXFACTOR()`IDENTICAL'"
#write <dcs.f> ""
#write <dcs.f> "      treetree=   DBLE(ctreetree)*dcsfactor !Should be anyway real"
#write <dcs.f> "      treeloop= 2*DBLE(ctreeloop)*dcsfactor"
#write <dcs.f> "      looploop=   DBLE(clooploop)*dcsfactor !Should be anyway real"
#write <dcs.f> "C ----------------------------------------------------------------------"
#write <dcs.f> "      return"
#write <dcs.f> "      end"


#else
** We create to avoid polemic in Makefile, in a future may have a meaning.
#write <fluxfactor.F> ""
#write <mandelstam.F> ""
#write <momentum.F> ""
#write <softphoton.F> ""
#write <dcs.f> ""
#endif

format rational spaces;
print +s +f;
.end





*$Id: joinkinematics.frm,v 1.17 2004/12/14 19:28:43 alorca Exp $
