C File <c0w.F> containing the C0 function for finite width
C This file is part of aITALC
C Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
C-----------------------------------------------------------------------
      double complex function C0w(index,
     &     P1S,P2S,P1P2S, !external momenta
     &     cM1S,cM2S,cM3S)
C-----------------------------------------------------------------------
      implicit none
      integer index
      double precision P1S,P2S,P1P2S
      double complex cM1S,cM2S,cM3S

      double complex C0i,B0w,A0w
      double complex C0w_ff,C0wcc0,C0wcc(7)
      double precision IG3,IG2
      integer i
      double precision widthalltogether,minmass

      logical
     &     lrenorm,        !renormalization flag .true./.false.
     &     lwidth,         !propagator's widths .true./.false.
     &     lidentCKM,      !Identity for CKM matrix .true./.false. 
     &     luvcheck,       !UV-check flag
     &     lircheck        !IR-check flag
      common /lflags/ lrenorm,lwidth,lidentCKM,luvcheck,lircheck
#include <variablelist.hf>
C-----------------------------------------------------------------------
*JUST to remember what index is related with which function, added bb's

*#define bb0 1
*#define bb1 2
*#define bb00 3
*#define bb11 4

*#define cc0 1
*#define cc1 2
*#define cc2 3
*#define cc00 4
*#define cc11 5
*#define cc12 6
*#define cc22 7
*#define cc001 8
*#define cc002 9
*#define cc111 10
*#define cc112 11
*#define cc122 12
*#define cc222 13
C-----------------------------------------------------------------------
C If we don't deal with a finite width, lets call looptools
      widthalltogether=IMAG(cM1S+cM2S+cM3S)
      minmass=DBLE(cM1S)
      if (DBLE(cM2S).LT.minmass) minmass=DBLE(cM2S)
      if (DBLE(cM3S).LT.minmass) minmass=DBLE(cM3S)
      if (.NOT.lwidth) then
 10     C0w=C0i(index,P1S,P2S,P1P2S,DBLE(cM1S),DBLE(cM2S),DBLE(cM3S))
        return
c      elseif ((widthalltogether.EQ.0d0).OR.(minmass.GT.0d0)) then
C Is not the case described down there
c        goto 10
c      elseif ((P1S.LT.0D0).OR.(P2S.LT.0D0).OR.(P1P2S.LT.0D0)) then
C No imaginary part is developed with negative P1S arguments.
c        goto 10
      endif
C-----------------------------------------------------------------------
C Normal computation for C_0
c      C0wcc(1)=C0wcc0(P1S,P2S,P1P2S,cM1S,cM2S,cM3S)
      C0wcc(1)=C0w_ff(P1S,P2S,P1P2S,cM1S,cM2S,cM3S)
C-----------------------------------------------------------------------
C Now that C0w has been calculated we specify the case
      IG2 = IGram2(P2S,P1S,P1P2S)
C-----------------------------------------------------------------------
      C0wcc(2) = 0
     &     + B0w(1,P1S,cM1S,cM2S) * (  - 2*P1S + 2*P2S - 2*P1P2S )
      C0wcc(2) = C0wcc(2) + B0w(1,P2S,cM2S,cM3S) * ( 2*P1S - 2*P2S
     &     - 2*P1P2S )
      C0wcc(2) = C0wcc(2) + B0w(1,P1P2S,cM1S,cM3S) * ( 4*P1P2S )
      C0wcc(2) = C0wcc(2) + C0wcc(1) * (  - 2*P1S*P1P2S + 2*P1S*cM1S
     &     - 2*P1S*cM3S - 2*P2S*P1P2S - 2*P2S*cM1S + 2*P2S*cM3S - 2
     &     *P1P2S*cM1S + 4*P1P2S*cM2S - 2*P1P2S*cM3S + 2*P1P2S**2 )
      C0wcc(2) = C0wcc(2)*IG2/4
      
      C0wcc(3) = 0
     &     + B0w(1,P1S,cM1S,cM2S) * ( 4*P1S )
      C0wcc(3) = C0wcc(3) + B0w(1,P2S,cM2S,cM3S) * (  - 2*P1S - 2
     &     *P2S+ 2*P1P2S )
      C0wcc(3) = C0wcc(3) + B0w(1,P1P2S,cM1S,cM3S) * (  - 2*P1S +
     &     2*P2S- 2*P1P2S )
      C0wcc(3) = C0wcc(3) + C0wcc(1) * (  - 2*P1S*P2S - 2*P1S*P1P2S
     &     - 2*P1S*cM1S - 2*P1S*cM2S + 4*P1S*cM3S + 2*P1S**2 - 2*P2S
     &     *cM1S +2*P2S*cM2S + 2*P1P2S*cM1S - 2*P1P2S*cM2S )
      C0wcc(3) = C0wcc(3)*IG2/4
C-----------------------------------------------------------------------

      C0wcc(4) = 0 
     &     + B0w(1,P2S,cM2S,cM3S)
      C0wcc(4) = C0wcc(4) + C0wcc(1) * ( 2*cM1S )
      C0wcc(4) = C0wcc(4) + C0wcc(2) * ( P1S + cM1S - cM2S )
      C0wcc(4) = C0wcc(4) + C0wcc(3) * ( P1P2S + cM1S - cM3S )
      C0wcc(4) = C0wcc(4) + 1
      C0wcc(4) = C0wcc(4)/4
      
      C0wcc(5) = + IG2 * (  - 2*P1P2S )
      C0wcc(5) = C0wcc(5) + B0w(2,P1S,cM1S,cM2S)*IG2 * (  - 2*P1S + 2
     &     *P2S- 2*P1P2S )
      C0wcc(5) = C0wcc(5) + B0w(2,P2S,cM2S,cM3S)*IG2 * (  - 2*P1S + 2
     &     *P2S+ 2*P1P2S )
      C0wcc(5) = C0wcc(5) + B0w(1,P2S,cM2S,cM3S)*IG2 * (  - 2*P1S + 2
     &     *P2S)
      C0wcc(5) = C0wcc(5) + C0wcc(1)*IG2 * (  - 4*P1P2S*cM1S )
      C0wcc(5) = C0wcc(5) + C0wcc(2)*IG2 * (  - 4*P1S*P1P2S + 2*P1S*cM1S
     &     -2*P1S*cM3S - 2*P2S*P1P2S - 2*P2S*cM1S + 2*P2S*cM3S - 4*P1P2S
     &     *cM1S + 6*P1P2S*cM2S - 2*P1P2S*cM3S + 2*P1P2S**2 )
      C0wcc(5) = C0wcc(5) + C0wcc(3)*IG2 * (  - 2*P1P2S*cM1S + 2*P1P2S
     &     *cM3S- 2*P1P2S**2 )
      C0wcc(5) = C0wcc(5)/4

      C0wcc(6) = + IG2 * ( P1S - P2S + P1P2S )
      C0wcc(6) = C0wcc(6) + B0w(2,P2S,cM2S,cM3S)*IG2 * ( 2*P1S - 2*P2S
     &     -2*P1P2S )
      C0wcc(6) = C0wcc(6) + B0w(2,P1P2S,cM1S,cM3S)*IG2 * ( 4*P1P2S )
      C0wcc(6) = C0wcc(6) + B0w(1,P2S,cM2S,cM3S)*IG2 * ( P1S - P2S +
     &     P1P2S )
      C0wcc(6) = C0wcc(6) + C0wcc(1)*IG2 * ( 2*P1S*cM1S - 2*P2S*cM1S + 2
     &     *P1P2S*cM1S )
      C0wcc(6) = C0wcc(6) + C0wcc(2)*IG2 * (  - P1S*P2S + P1S*P1P2S +
     &     P1S*cM1S - P1S*cM2S + P1S**2 - P2S*cM1S + P2S*cM2S + P1P2S
     &     *cM1S- P1P2S*cM2S )
      C0wcc(6) = C0wcc(6) + C0wcc(3)*IG2 * (  - P1S*P1P2S + 3*P1S*cM1S -
     &     3*P1S*cM3S - 3*P2S*P1P2S - 3*P2S*cM1S + 3*P2S*cM3S - P1P2S
     &     *cM1S+ 4*P1P2S*cM2S - 3*P1P2S*cM3S + 3*P1P2S**2 )
      C0wcc(6) = C0wcc(6)/4
      
      C0wcc(7) =  + IG2 * (  - 2*P1S )
      C0wcc(7) = C0wcc(7) + B0w(2,P2S,cM2S,cM3S)*IG2 * (  - 2*P1S - 2
     &     *P2S+ 2*P1P2S )
      C0wcc(7) = C0wcc(7) + B0w(2,P1P2S,cM1S,cM3S)*IG2 * (  - 2*P1S +
     &     2*P2S - 2*P1P2S )
      C0wcc(7) = C0wcc(7) + B0w(1,P2S,cM2S,cM3S)*IG2 * (  - 2*P1S )
      C0wcc(7) = C0wcc(7) + C0wcc(1)*IG2 * (  - 4*P1S*cM1S )
      C0wcc(7) = C0wcc(7) + C0wcc(2)*IG2 * (  - 2*P1S*cM1S + 2*P1S*cM2S
     &     - 2*P1S**2 )
      C0wcc(7) = C0wcc(7) + C0wcc(3)*IG2 * (  - 2*P1S*P2S - 4*P1S*P1P2S
     &     - 4*P1S*cM1S - 2*P1S*cM2S + 6*P1S*cM3S + 2*P1S**2 - 2*P2S
     &     *cM1S+ 2*P2S*cM2S + 2*P1P2S*cM1S - 2*P1P2S*cM2S )
      C0wcc(7) = C0wcc(7)/4
C-----------------------------------------------------------------------
      do i=1,7
        if (index.EQ.i) C0w=C0wcc(i)
      enddo
C-----------------------------------------------------------------------
      return
      end

CC $Id: c0w.F,v 1.7 2004/10/14 11:27:27 alorca Exp $
